diff -purN OLD/board/xsengine/flash.c NEW/board/xsengine/flash.c
--- OLD/board/xsengine/flash.c	2004-07-01 18:30:46.000000000 +0200
+++ NEW/board/xsengine/flash.c	2005-04-18 14:59:45.000000000 +0200
@@ -179,13 +179,9 @@ void flash_print_info  (flash_info_t *in
 	}
 
 	switch (info->flash_id & FLASH_TYPEMASK) {
-	case FLASH_AMLV128U:	printf ("AM29LV128ML (128Mbit, uniform sector size)\n");
-				break;
-	case FLASH_AMLV320U:	printf ("AM29LV320ML (32Mbit, uniform sector size)\n");
-				break;
 	case FLASH_AMLV640U:	printf ("AM29LV640ML (64Mbit, uniform sector size)\n");
 				break;
-	case FLASH_AMLV320B:	printf ("AM29LV320MB (32Mbit, bottom boot sect)\n");
+	case FLASH_S29GL064M:	printf ("S29GL064M (64Mbit, top boot sector size)\n");
 				break;
 	default:		printf ("Unknown Chip Type\n");
 				break;
@@ -252,17 +248,6 @@ static ulong flash_get_size (vu_long *ad
 		debug ("Mirror Bit flash: addr[14] = %08lX  addr[15] = %08lX\n",
 			addr[14], addr[15]);
 		switch(addr[14]) {
-		case AMD_ID_LV128U_2:
-			if (addr[15] != AMD_ID_LV128U_3) {
-				debug ("Chip: AMLV128U -> unknown\n");
-				info->flash_id = FLASH_UNKNOWN;
-			} else {
-				debug ("Chip: AMLV128U\n");
-				info->flash_id += FLASH_AMLV128U;
-				info->sector_count = 256;
-				info->size = 0x02000000;
-			}
-			break;				/* => 32 MB	*/
 		case AMD_ID_LV640U_2:
 			if (addr[15] != AMD_ID_LV640U_3) {
 				debug ("Chip: AMLV640U -> unknown\n");
@@ -274,17 +259,17 @@ static ulong flash_get_size (vu_long *ad
 				info->size = 0x01000000;
 			}
 			break;				/* => 16 MB	*/
-		case AMD_ID_LV320B_2:
-			if (addr[15] != AMD_ID_LV320B_3) {
-				debug ("Chip: AMLV320B -> unknown\n");
+		case AMD_ID_GL064MT_2:
+			if (addr[15] != AMD_ID_GL064MT_3) {
+				debug ("Chip: S29GL064M-R3 -> unknown\n");
 				info->flash_id = FLASH_UNKNOWN;
 			} else {
-				debug ("Chip: AMLV320B\n");
-				info->flash_id += FLASH_AMLV320B;
-				info->sector_count = 71;
-				info->size = 0x00800000;
+				debug ("Chip: S29GL064M-R3\n");
+				info->flash_id += FLASH_S29GL064M;
+				info->sector_count = 128;
+				info->size = 0x01000000;
 			}
-			break;				/* =>  8 MB	*/
+			break;				/* => 16 MB	*/
 		default:
 			debug ("Chip: *** unknown ***\n");
 			info->flash_id = FLASH_UNKNOWN;
diff -purN OLD/include/flash.h NEW/include/flash.h
--- OLD/include/flash.h	2004-12-16 19:01:48.000000000 +0100
+++ NEW/include/flash.h	2005-04-18 14:47:49.000000000 +0200
@@ -198,6 +198,8 @@ extern void flash_read_factory_serial(fl
 #define AMD_ID_LV256U_3 0x22012201	/* 3rd ID word for AM29LV256M  at 0x3c */
 #define AMD_ID_GL064M_2 0x22132213	/* 2nd ID word for S29GL064M-R6 */
 #define AMD_ID_GL064M_3 0x22012201	/* 3rd ID word for S29GL064M-R6 */
+#define AMD_ID_GL064MT_2 0x22102210	/* 2nd ID word for S29GL064M-R3 (top boot sector) */
+#define AMD_ID_GL064MT_3 0x22012201	/* 3rd ID word for S29GL064M-R3 (top boot sector) */
 
 #define AMD_ID_LV320B_2	0x221A221A	/* 2d ID word for AM29LV320MB at 0x38 */
 #define AMD_ID_LV320B_3 0x22002200	/* 3d ID word for AM29LV320MB at 0x3c */
